#if !defined(_ALPHA_TELEX_H_INCLUDED_)
#define _ALPHA_TELEX_H_INCLUDED_ 1

#pragma pack(1)		//    1 

//    
enum _ELEMENT_TYPE_ {
	ET_RECEIVED,			// 0   -   
	ET_FOR_SENDING,			// 1   -    
	ET_SENT,				// 2   -   
	ET_DELETE_AFTER_SEND,	// 3   -     
	ET_DELETE_READ,			// 4   -    ()
	ET_AUTOANSWER			// 5   -   
};


//  
enum _ERROR_CODE_ {
	EC_NO_ERRORS,			// 00    
	EC_NUM_STATION,			// 01       -
							//        
	EC_SEND_LIMIT_ATTEMPT,	// 02     
	EC_CALL_LIMIT_ATTEMPT,	// 03     
	EC_NUM_AUTOANSWER,		// 04     
							//        
	EC_CALL_AUTOANSWER,		// 05     
							//      
	EC_RECV_BUFFER_FULL,	// 06        -  
	EC_USER_BREAK,			// 07  /    
	EC_READ_FROM_FLASH,		// 08    
	EC_FORCE_DISCONNECT,	// 09  BK  -  '
	EC_ABS_NOT_WORKING,		// 10  ABS -    
	EC_CI_NETWORK_ERROR,	// 11  CI  -   
	EC_DER_NETWORK_ERROR,	// 12  DER -    
	EC_ABONENT_DISABLED,	// 13  NA  -    
	EC_ALPHA_LINK_ERR,		// 14    ALPHA_LINK
	EC_NP_NUM_ERR,			// 15  NP  -  
	EC_ABONENT_BREAK,		// 16       
	EC_DONT_RECV_WHOIS,		// 17     
	EC_OCC_ERROR,			// 18  OCC
	EC_NC_ERROR,			// 19  NC
	EC_DONT_RECV_AUTOANSWER,// 20    
	EC_XXX_TRANSMIT,		// 21   
	EC_NO_INVITE_FOR_NUM,	// 22      
	EC_NO_STATION_ACTION,	// 23       
	EC_BUSY_IMPULSE,		// 24   
	EC_BAD_LINE,			// 25    -  
	EC_USER_CANCEL_QUEUE,	// 26      
	EC_RECV_CKS_PAUSE,		// 27      
	EC_NO_DIALTONE,			// 28   
	EC_TOO_LATE,			// 29    
	EC_SPEC_USER_BREAK		// 30        
							//           -
							//     .    
};

//    
struct HeaderRecevedMsg {
	union {
		unsigned short size;	//    
		struct {
			BYTE al;			//  
			BYTE ah;			//  
		} usize;
	};
	BYTE type;				//   - //
	BYTE errcode;			//   ()
	BYTE year;				//   (-1980)
	BYTE month;				//  
	BYTE day;				//  
	BYTE hh;				//  
	BYTE mm;				//  
	BYTE reserved;			// 
};

//    
struct HeaderSendMsg {
	WORD size;	//    
	BYTE type;				//   - ///
	BYTE errcode;			//   ()
	BYTE year;				//   (-1980)
	BYTE month;				//  
	BYTE day;				//  
	BYTE hh;				//  
	BYTE mm;				//  
	BYTE prty;				//   X1_X2
	BYTE callcounter;		//   
	DWORD uid;				// DWORD 
	BYTE badcallssum;		//    ()
	BYTE badcallspod;		//    ()
	union {
		unsigned short num;	//    XYZ
		struct {
			BYTE uYZ;		// 1X
			BYTE u1X;		// YZ
		} ubyte;
	} uchecknum;
	struct {				//   
		BYTE b1;
		BYTE b2;
		BYTE b3;
		BYTE b4;
		BYTE b5;
	} call;
	BYTE queuenum;			// ()            
							//             
};


//      -
//
class CAlphaTelex {
	HANDLE hCom;
	DWORD dwError;
	DWORD m_Errors;
	DWORD dw;
	BOOL fSuccess;
	DWORD m_EventMask;
	COMMTIMEOUTS comt;
	DCB dcb;
	BYTE ans;
	BYTE cmd;
public:
	//    
	BOOL _DecrementRecv();
	BOOL _ManualScanner();
	BOOL _SendDigit(BYTE n);
	BOOL _SendByte(BYTE b);
	BOOL _AutoAnswer();
	BOOL _ManualCall();
	BOOL _SendBreak();
	BYTE _ClearFlash();
	BOOL _PokeInternalOr(BYTE addr,BYTE b);
	BOOL _PokeInternalAnd(BYTE addr,BYTE b);
	BOOL _Poke(BYTE b);
	BOOL _Poke(unsigned short addr,BYTE b);
	BOOL _PokeInternal(BYTE addr,BYTE b);
	BYTE _PeekInternal(BYTE addr);
	BYTE _Peek();
	BYTE _Peek(unsigned short addr);
	BOOL _Reset();
	BYTE _GetModemState();
public:
	void ClearBuffer();
	CRITICAL_SECTION critical_section;
	BOOL SetFreeAddress(unsigned short addr);
	BOOL GetBufferByte(BYTE *b,BOOL wait=TRUE);
	DWORD buflenmax;
	DWORD buflen;
	BYTE * buffer;
	BOOL ReadByte(BYTE *b);
	BOOL fReadInProgress;
	BOOL fWaitingOnRead;
	OVERLAPPED m_ovpr;
	OVERLAPPED m_ovpw;
	BOOL WriteByte(BYTE b);
	//  
	void SetParamCKSCallSignalLen(BYTE b);
	BYTE GetParamCKSCallSignalLen();
	void SetParamCKSAbendTime(BYTE b);
	BYTE GetParamCKSAbendTime();
	void SetParamCKSSignalToUploadNewOutgoing(BYTE b);
	BYTE GetParamCKSSignalToUploadNewOutgoing();
	void SetParamCKSBlockXXXTransmitOnHalfDuplex(BOOL f);
	BOOL GetParamCKSBlockXXXTransmitOnHalfDuplex();
	void SetParamCKSHalfDuplexMode(BOOL f);
	BOOL GetParamCKSHalfDuplexMode();
	void SetParamCKSAutoSelectCodeCombination(BOOL f);
	BOOL GetParamCKSAutoSelectCodeCombination();
	void SetParamCKSMakeFLASHProtocol(BOOL f);
	BOOL GetParamCKSMakeFLASHProtocol();
	void SetParamCKSDontArchivePauseError(BOOL f);
	BOOL GetParamCKSDontArchivePauseError();
	void SetParamCKSAfterDelimiterTextVK(BOOL f);
	BOOL GetParamCKSAfterDelimiterTextVK();
	void SetParamCKSNNNDelimiter(BOOL f);
	BOOL GetParamCKSNNNDelimiter();
	void SetParamCKSNNNNDelimiter(BOOL f);
	BOOL GetParamCKSNNNNDelimiter();
	void SetParamCKSPauseAsDelimiter(BYTE b);
	BYTE GetParamCKSPauseAsDelimiter();
	void SetParamCKSBufferSize(BYTE b);
	BYTE GetParamCKSBufferSize();
	void SetParamAddToBufferAutoanswer(BOOL f);
	BOOL GetParamAddToBufferAutoanswer();
	void SetParamPauseBeforeInviteToNumber(BYTE b);
	BYTE GetParamPauseBeforeInviteToNumber();
	void SetParamModemReceiveMode(BYTE b);
	BYTE GetParamModemReceiveMode();
	void SetParamMaxLenSinalInUse(BYTE b);
	BYTE GetParamMaxLenSinalInUse();
	void SetParamMinLenSinalInUse(BYTE b);
	BYTE GetParamMinLenSinalInUse();
	void SetParamNumberDigitInterval(BYTE b);
	BYTE GetParamNumberDigitInterval();
	void SetParamLimitUneffAttemptsForOneDir(BYTE b);
	BYTE GetParamLimitUneffAttemptsForOneDir();
	void SetParamMaxModemRAMUsage(BYTE b);
	BYTE GetParamMaxModemRAMUsage();
	void SetParamMinTimeImpulseInviteForNumber(BYTE b);
	BYTE GetParamMinTimeImpulseInviteForNumber();
	void SetParamBreakLen(BYTE b);
	BYTE GetParamBreakLen();
	void SetParamStopBitLen05(BOOL f);
	BOOL GetParamStopBitLen05();
	void SetParamReceiverMode(BOOL f);
	BOOL GetParamReceiverMode();
	void SetParamDelayOnUnsucAttempt(BYTE b);
	BYTE GetParamDelayOnUnsucAttempt();
	void SetParamDelayBeforeSendingAutoanswer(BYTE b);
	BYTE GetParamDelayBeforeSendingAutoanswer();
	void SetParamWaitForAutoanser(BYTE b);
	BYTE GetParamWaitForAutoanser();
	void SetParamWaitForNumberStation(BYTE b);
	BYTE GetParamWaitForNumberStation();
	void SetParamWaitInviteForNumberA(BYTE b);
	BYTE GetParamWaitInviteForNumberA();
	void SetParamQueueOffOnBreakWhenSending(BOOL f);
	BOOL GetParamQueueOffOnBreakWhenSending();
	void SetParamBeginRecvOnXXXSend(BOOL f);
	BOOL GetParamBeginRecvOnXXXSend();
	void SetParamQueueOffOnXXXSend(BOOL f);
	BOOL GetParamQueueOffOnXXXSend();
	void SetParamSendBreakOnXXXSend(BOOL f);
	BOOL GetParamSendBreakOnXXXSend();
	void SetParamAttemptLimit(BYTE f);
	BYTE GetParamAttemptLimit();
	void SetParamAllowSoundOn12UUU_CKS(BOOL f);
	BOOL GetParamAllowSoundOn12UUU_CKS();
	void SetParamAllowSoundOnCall(BOOL f);
	BOOL GetParamAllowSoundOnCall();
	void SetParamMaxTimeImpulseInviteNumber(BYTE b);
	BYTE GetParamMaxTimeImpulseInviteNumber();
	void GetParamDelayBeforeBreak(BYTE b);
	BYTE GetParamDelayBeforeBreak();
	void SetParamTimeIntervalValueNumber(BYTE b);
	BYTE GetParamTimeIntervalValueNumber();
	void SetParamTimeMinusValueNumber(BYTE b);
	BYTE GetParamTimeMinisValueNumber();
	void SetParamTimePlusValueNumber(BYTE b);
	BYTE GetParamTimePlusValueNumber();
	void SetParamPreNumberBTimeout(BYTE b);
	BYTE GetParamPreNumberBTimeout();
	void SetParamPreNumberATimeout(BYTE b);
	BYTE GetParamPreNumberATimeout();
	void SetParamHangProtectTimeout(BYTE b);
	BYTE GetParamHangProtectTimeout();
	void SetParamWriteAutoanswerToMemoryForInCall(BOOL f);
	BOOL GetParamWriteAutoanswerToMemoryForInCall();
	void SetParamRequireWhoIsForInCall(BOOL f);
	BOOL GetParamRequireWhoIsForInCall();
	void SetParamTimeToFixBreak(BYTE b);
	BYTE GetParamTimeToFixBreak();
	void SetParamSendWhoIsIfNoAnswer(BOOL f);
	BOOL GetParamSendWhoIsIfNoAnswer();
	void SetParamAllowSpecProtocolRecv(BOOL f);
	BOOL GetParamAllowSpecProtocolRecv();
	void SetParamAllowSpecProtocolSend(BOOL f);
	BOOL GetParamAllowSpecProtocolSend();
	void SetParamAutoanswerDelayText(BYTE b);
	BYTE GetParamAutoanswerDelayText();
	void SetParamLineBPS(unsigned short bps);
	unsigned short GetParamLineBPS();
	BYTE GetPagamSendLoopTime();
	void SetPagamSendLoopTime(BYTE n);
	void SetPagamMinTlgSise4Sound(BYTE n);
	BYTE GetPagamMinTlgSise4Sound();
	void SetParamSound_CKS_Tlg(BOOL f);
	BOOL GetParamSound_CKS_Tlg();
	void SetParamSoundOnceTlg(BOOL f);
	BOOL GetParamSoundOnceTlg();
	void SetParamSoundContTlg(BOOL f);
	BOOL GetParamSoundContTlg();
	void SetParamSound15Tlg(BOOL f);
	BOOL GetParamSound15Tlg();
	unsigned short GetFreeFlashAddress();
	BOOL GetFlashStatus();
	BOOL SetFlashOperations(BOOL f);
	unsigned short GetMemorySize();
	unsigned short GetFreeAddress();
	unsigned short GetCurrentTlgAddress();
	BYTE GetByte();
	BOOL SetModemTime(COleDateTime dtime);
	BOOL SetIBMReadMode(BOOL f);
	BOOL IsModeRecv();
	BOOL IsModeSend();
	BOOL HaveRecvTlgs();
	BOOL HaveSentTlgs();
	BOOL SetTraceMode(BOOL f);
	BOOL CanAccessBuffer();
	BOOL SetRecvLockMode(BOOL f);
	// constructor
	CAlphaTelex();
	~CAlphaTelex();
	// general operations
	BOOL Connect(CString port);
	BOOL Disconnect();
};

//    
struct AlphaFlags2C_Struct {
    BOOL b_Reserved1 : 4;		// 0..3 - 
    BOOL b_Dont_Recv : 1;		// 4 - W     
    BOOL b_Cant_Read_Buf : 1;	// 5 - R       
    BOOL b_Trace_On : 1;		// 6 - W    
    BOOL b_Reserved2 : 1;		// 7 - 
};

union AlphaFlags2C {
	AlphaFlags2C_Struct flags;
	BYTE byte;
};

struct AlphaFlags2D_Struct {
    BOOL b_Reserved1 : 3;		// 0..2 - 
    BOOL b_Have_Sent_Tlgs : 1;	// 3 - R     
    BOOL b_Have_Recv_Tlgs : 1;	// 4 - R     
    BOOL b_Reserved2 : 1;		// 5 - 
    BOOL b_Mode_Recv: 1;		// 6 - R   
    BOOL b_Mode_Send: 1;		// 7 - R   
};

union AlphaFlags2D {
	AlphaFlags2D_Struct flags;
	BYTE byte;
};

struct AlphaFlags2E_Struct {
    BOOL b_Reserved1 : 2;		// 0..1 - 
    BOOL b_IBM_Read : 1;		// 3 - W    ( )
    BOOL b_Reserved2 : 5;		// 0..1 - 
};

union AlphaFlags2E {
	AlphaFlags2E_Struct flags;
	BYTE byte;
};

//    
struct AlphaFlagsByte_Struct {
	BOOL bit0 : 1;
	BOOL bit1 : 1;
	BOOL bit2 : 1;
	BOOL bit3 : 1;
	BOOL bit4 : 1;
	BOOL bit5 : 1;
	BOOL bit6 : 1;
	BOOL bit7 : 1;
};

union AlphaFlagsByte {
	AlphaFlagsByte_Struct flags;
	BYTE byte;
};

#endif