// Armt.cpp : Defines the class behaviors for the application.
//

#include "stdafx.h"
#include <locale.h>
#include "Armt.h"
#include "ArmtDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CArmtApp

BEGIN_MESSAGE_MAP(CArmtApp, CWinApp)
	//{{AFX_MSG_MAP(CArmtApp)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CArmtApp construction

CArmtApp::CArmtApp()
{
	// TODO: add construction code here,
	// Place all significant initialization in InitInstance
	InitializeCriticalSection(&crs);
}

/////////////////////////////////////////////////////////////////////////////
// The one and only CArmtApp object

CArmtApp theApp;

/////////////////////////////////////////////////////////////////////////////
// CArmtApp initialization

BOOL CArmtApp::InitInstance()
{
	CArmtDlg dlg;
	CString title;

	if (!AfxSocketInit())
	{
		AfxMessageBox(IDP_SOCKETS_INIT_FAILED);
		return FALSE;
	}

	AfxEnableControlContainer();
	if (!AfxInitRichEdit()) {
		AfxMessageBox("   Windows,   RichEdit",
			MB_ICONEXCLAMATION|MB_OK);
		goto fin;
	}

	setlocale(LC_ALL,"Russian");

	// Standard initialization
	// If you are not using these features and wish to reduce the size
	//  of your final executable, you should remove from the following
	//  the specific initialization routines you do not need.

#ifdef _AFXDLL
	Enable3dControls();			// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

	m_pMainWnd = &dlg;

	// registry settings
	delete (char *)m_pszRegistryKey;
	m_pszRegistryKey=_tcsdup(_T("PVRRCC Saratov\\Armt"));
	ReadParam();


	title.LoadString(IDS_TITLE);
	if (FindWindow(NULL,title)) {
		AfxMessageBox("    ",MB_ICONEXCLAMATION|MB_OK);
		goto fin;
	}

	dlg.DoModal();
	WriteParam();

fin:
	return FALSE;
}

void CArmtApp::ReadParam()
{
	// 
	m_param.nChanels=GetProfileInt(PROFILE_SECTION,PARAM_NCHANNELS,0);
	for (int i=0; i<m_param.nChanels; i++) {
		CString cs; cs.Format("%02d",i);
		m_param.PortName.Add(GetProfileString(PROFILE_SECTION+cs,PARAM_PORTNAME,"COMx"));
		m_param.ChTimeout.Add(GetProfileInt(PROFILE_SECTION+cs,PARAM_CHTIMEOUT,-1));
		m_param.AutoText.Add(GetProfileString(PROFILE_SECTION+cs,PARAM_ATEXT,"   3"));
	}
	//  
	m_param.db_server=GetProfileString(PROFILE_SECTION,PARAM_DB_SERVER,"");
	m_param.db_base=GetProfileString(PROFILE_SECTION,PARAM_DB_BASE,"");
	m_param.db_user=GetProfileString(PROFILE_SECTION,PARAM_DB_USER,"");
	m_param.db_passwd=GetProfileString(PROFILE_SECTION,PARAM_DB_PASS,"");
	//  
	m_param.com_soundall=GetProfileInt(PROFILE_SECTION,PARAM_COM_SOUNDALL,1);
	m_param.com_ask999=GetProfileInt(PROFILE_SECTION,PARAM_COM_ASK999,1);
	m_param.com_logfile=GetProfileString(PROFILE_SECTION,PARAM_COM_LOGFILE,"c:\\armt.log");
	m_param.com_divide=GetProfileInt(PROFILE_SECTION,PARAM_COM_DIVIDE,1);
	m_param.com_trash=GetProfileInt(PROFILE_SECTION,PARAM_COM_TRASH,50);
}

void CArmtApp::WriteParam()
{
	// 
	WriteProfileInt(PROFILE_SECTION,PARAM_NCHANNELS,m_param.nChanels);
	for (int i=0; i<m_param.nChanels; i++) {
		CString cs; cs.Format("%02d",i);
		WriteProfileString(PROFILE_SECTION+cs,PARAM_PORTNAME,m_param.PortName[i]);
		WriteProfileInt(PROFILE_SECTION+cs,PARAM_CHTIMEOUT,m_param.ChTimeout[i]);
		WriteProfileString(PROFILE_SECTION+cs,PARAM_ATEXT,m_param.AutoText[i]);
	}
	//  
	WriteProfileString(PROFILE_SECTION,PARAM_DB_SERVER,m_param.db_server);
	WriteProfileString(PROFILE_SECTION,PARAM_DB_BASE,m_param.db_base);
	WriteProfileString(PROFILE_SECTION,PARAM_DB_USER,m_param.db_user);
	WriteProfileString(PROFILE_SECTION,PARAM_DB_PASS,m_param.db_passwd);
	//  
	WriteProfileInt(PROFILE_SECTION,PARAM_COM_SOUNDALL,m_param.com_soundall);
	WriteProfileInt(PROFILE_SECTION,PARAM_COM_ASK999,m_param.com_ask999);
	WriteProfileString(PROFILE_SECTION,PARAM_COM_LOGFILE,m_param.com_logfile);
	WriteProfileInt(PROFILE_SECTION,PARAM_COM_DIVIDE,m_param.com_divide);
	WriteProfileInt(PROFILE_SECTION,PARAM_COM_TRASH,m_param.com_trash);
}

void CArmtApp::ClearParam()
{
	m_param.nChanels=0;
	m_param.PortName.RemoveAll();
	m_param.ChTimeout.RemoveAll();
	m_param.AutoText.RemoveAll();
}

void CArmtApp::Ecs()
{
	EnterCriticalSection(&crs);
}

extern "C" WINBASEAPI BOOL WINAPI TryEnterCriticalSection(LPCRITICAL_SECTION);

BOOL CArmtApp::Ecst()
{
	return TryEnterCriticalSection(&crs);
}

void CArmtApp::Lcs()
{
	LeaveCriticalSection(&crs);
}

CString CArmtApp::GetTlgNumber(CString buf)
{
	CString tlg_no;
	BYTE b;
	int i,j;

	//    ( )
	i=buf.Find("  ");				// -
	if (i==-1) i=buf.Find(" HP ");	// 
	if (i==-1) i=buf.Find(" H ");	// /
	if (i==-1) i=buf.Find("  ");	// /
	if (i>=0) {
		i+=4;
		for ( ; i<buf.GetLength() && buf[i]==' '; i++) ;	//  
		for (j=i; j<buf.GetLength(); j++) {
			b=buf[j];
			switch (b) {
			case (BYTE)'': tlg_no+='4'; break;
			case (BYTE)'  ': goto fin;
			case (BYTE)'\r': goto fin;
			case (BYTE)'\n': goto fin;
			default: tlg_no+=b;
			}
			if (tlg_no.GetLength()>=10) goto fin;
		}
	}

fin:
	if (tlg_no.GetLength()<1) tlg_no="999999";	//   

	return tlg_no;
}

CStringArray& CArmtApp::GetTlgCountArray(CString buf,CStringArray &arr,CWordArray &iarr)
{
	int num=0,i,j,cc,sht_nr_len;
	CString tlg_no;
	BYTE b;

	arr.RemoveAll();	//    
	iarr.RemoveAll();	//    

	// ,   
	i=buf.Find("  ");				// -
	if (i==-1) i=buf.Find(" T ");	// 
	if (i==-1) goto fin;
	for (j=i+3; j<buf.GetLength() && (buf[j]==' ' ||
		buf[j]=='\r' || buf[j]=='\n'); j++) ;	// 

	if (buf.GetLength()-j<=3) goto fin;
	if (buf.Mid(j,3)==" " ||		// -
		buf.Mid(j,3)=="HP ") ;		// 
	else goto fin;
	sht_nr_len=j-i+3;

	// ,    CCCC
	cc=buf.Find("CCCC");				// 
	if (cc==-1) cc=buf.Find("");	// -
	if (cc==-1) cc=buf.Find("");	// -
	if (cc==-1 && buf.Find("FFFF")!=-1) cc=i+1;
	if (cc==-1 && buf.Find("")!=-1) cc=i+1;
	if (cc==-1 && buf.Find("\r\n\r\n\r\n\r\n\r\n\r\n")!=-1) cc=i+1;
	if (cc==-1) goto fin;

	//      - 
	if (i>cc) goto fin;

	//    
	j=buf.Left(i).ReverseFind(' ');
	if (j!=-1) {
		CString tmp,cs;
		if (buf.GetLength()-j-1<=i-j) goto fin;
		tmp=buf.Mid(j+1,i-j);
		for (int k=0; k<tmp.GetLength(); k++) {
			b=tmp[k];
			switch (b) {
			case (BYTE)'': cs+='4'; break;
			case (BYTE)' ': goto enddigit;
			case (BYTE)'\r': goto enddigit;
			case (BYTE)'\n': goto enddigit;
			default: cs+=b;
			}
			if (cs.GetLength()>=5) break;
		}
enddigit:
		num=atoi(cs);
	}
	if (num<1) goto fin;

	if (buf.GetLength()<=i+sht_nr_len) goto fin;
	buf=buf.Mid(i+sht_nr_len);	//    	'   '

	for (j=0; j<num; j++) {
		tlg_no="";
		//     
		for (i=0; i<buf.GetLength() && buf[i]==' '; i++) ;
		for ( ; i<buf.GetLength(); i++) {
			b=buf[i];
			switch (b) {
			case (BYTE)'': tlg_no+='4'; break;
			case (BYTE)' ': goto endnum;
			case (BYTE)'\r': goto endnum;
			case (BYTE)'\n': goto endnum;
			default: tlg_no+=b;
			}
			if (tlg_no.GetLength()>=10) break;
		}
endnum:
		if (tlg_no.GetLength()>0) {
			arr.Add(tlg_no);
			iarr.Add(0);
		} else break;
		if (buf.GetLength()<=i) goto fin;
		buf=buf.Mid(i);	//    
	}
fin:

	return arr;
}

