// onfigTlg.cpp : implementation file
//

#include "stdafx.h"
#include "Armt.h"
#include "ConfigTlg.h"
#include "BrowseCtrl.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CConfigTlg dialog


CConfigTlg::CConfigTlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConfigTlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConfigTlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
}


void CConfigTlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConfigTlg)
	DDX_Control(pDX, IDC_LIST, m_list);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CConfigTlg, CDialog)
	//{{AFX_MSG_MAP(CConfigTlg)
	ON_BN_CLICKED(IDC_ADD, OnAdd)
	ON_BN_CLICKED(IDC_DEL, OnDel)
	ON_BN_CLICKED(IDC_EDIT, OnEdit)
	ON_NOTIFY(NM_CLICK, IDC_LIST, OnClickList)
	ON_NOTIFY(LVN_KEYDOWN, IDC_LIST, OnKeydownList)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// ConfigTlg message handlers

BOOL CConfigTlg::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	// TODO: Add extra initialization here
	m_list.AddColumn("");
	m_list.AddColumn("  ");
	m_list.AddColumn(" ,  ");
	m_list.AddColumn("        ");

	//  m_list
	char tmp[MAXITEMSTR+1];
	for (int i=0; i<GetApp()->m_param.nChanels; i++) {
		//  
		sprintf(tmp," %02d ",i);
		m_list.AddItem(0,tmp,i);
		//  
		m_list.AddItem(1,GetApp()->m_param.PortName[i]);
		// , 
		sprintf(tmp,"  %d ",GetApp()->m_param.ChTimeout[i]);
		m_list.AddItem(2,tmp);
		// 
		m_list.AddItem(3,GetApp()->m_param.AutoText[i]);
	}

	if (m_list.GetNumItems()) m_list.SelectItem(0);
	ShowSelectionChanged();
	
	return TRUE;  // return TRUE unless you set the focus to a control
	              // EXCEPTION: OCX Property Pages should return FALSE
}


void CConfigTlg::OnAdd() 
{
	// TODO: Add your control notification handler code here
	char tmp[MAXITEMSTR+1];

	//  
	sprintf(tmp," %02d ",m_list.GetNumItems());
	m_list.AddItem(0,tmp,m_list.GetNumItems());
	
	//  
	GetDlgItem(IDC_PORT)->GetWindowText(tmp,MAXITEMSTR);
	m_list.AddItem(1,tmp);

	// , 
	GetDlgItem(IDC_CHTIMEOUT)->GetWindowText(tmp,MAXITEMSTR);
	sprintf(tmp,"  %d ",atoi(tmp));
	m_list.AddItem(2,tmp);

	// 
	GetDlgItem(IDC_ATEXT)->GetWindowText(tmp,MAXITEMSTR);
	m_list.AddItem(3,tmp);
}

void CConfigTlg::OnOK() 
{
	// TODO: Add extra validation here
	GetApp()->ClearParam();
	for (int i=0; i<m_list.GetNumItems(); i++) {
		GetApp()->m_param.PortName.Add(m_list.GetItemText(i,1));
		int ns=atoi(m_list.GetItemText(i,2));
		if (ns<1 || ns>120) ns=10;
		GetApp()->m_param.ChTimeout.Add(ns);
		GetApp()->m_param.AutoText.Add(m_list.GetItemText(i,3));
	}
	GetApp()->m_param.nChanels=m_list.GetNumItems();
	GetApp()->WriteParam();
	
	CDialog::OnOK();
}

void CConfigTlg::OnDel() 
{
	// TODO: Add your control notification handler code here
	int r=m_list.GetSelected();
	if (r>=0) m_list.DeleteItem(r);
	else Beep(5000,50);
}

void CConfigTlg::OnEdit() 
{
	// TODO: Add your control notification handler code here
	char tmp[MAXITEMSTR+1];
	int r=m_list.GetSelected();

	if (r>=0) {
		//  
		GetDlgItem(IDC_PORT)->GetWindowText(tmp,MAXITEMSTR);
		m_list.ChangeItem(r,1,tmp);

		// , 
		GetDlgItem(IDC_CHTIMEOUT)->GetWindowText(tmp,MAXITEMSTR);
		sprintf(tmp,"  %d ",atoi(tmp));
		m_list.ChangeItem(r,2,tmp);

		// 
		GetDlgItem(IDC_ATEXT)->GetWindowText(tmp,MAXITEMSTR);
		m_list.ChangeItem(r,3,tmp);
	} else {
		Beep(5000,50);
	}
}

void CConfigTlg::OnClickList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	// TODO: Add your control notification handler code here
	ShowSelectionChanged();
	
	*pResult = 0;
}

void CConfigTlg::OnKeydownList(NMHDR* pNMHDR, LRESULT* pResult) 
{
	LV_KEYDOWN* pLVKeyDow = (LV_KEYDOWN*)pNMHDR;
	// TODO: Add your control notification handler code here
	ShowSelectionChanged();
	
	*pResult = 0;
}

void CConfigTlg::ShowSelectionChanged()
{
	int i=m_list.GetSelected();
	if (i>=0) {
		GetDlgItem(IDC_PORT)->SetWindowText(m_list.GetItemText(i,1));
		GetDlgItem(IDC_CHTIMEOUT)->SetWindowText(m_list.GetItemText(i,2));
		GetDlgItem(IDC_ATEXT)->SetWindowText(m_list.GetItemText(i,3));
	}
}
