#include "stdafx.h"

#include "telex.h"

#define SEND_MEM_LIMIT	(4096*2)		//   

//   ->  2
static BYTE alt_mtk_table[256]={  
/*     1    2    3    4    5    6    7    8    9    A    B    C    D    E    F  */
0x00,0x04,0x08,0x04,0x04,0x09,0x04,0x04,0x02,0x04,0x02,0x1b,0x04,0x08,0x04,0x1f, /* 0 */
0x00,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x1B,0x19,0x04,0x04,0x1f, /* 1 */
0x04,0x04,0x05,0x00,0x1f,0x04,0x1b,0x05,0x0F,0x12,0x04,0x11,0x0C,0x03,0x1C,0x1D, /* 2 */
0x16,0x17,0x13,0x01,0x0a,0x10,0x15,0x07,0x06,0x18,0x0e,0x04,0x04,0x1E,0x04,0x19, /* 3 */
0xc0,0x03,0x19,0x0e,0x09,0x01,0x0D,0x1A,0x14,0x06,0x0B,0x0F,0x12,0x1C,0x0C,0x18, /* 4 */
0x16,0x17,0x0a,0x05,0x10,0x07,0x1E,0x13,0x1D,0x15,0x11,0x82,0x04,0x81,0x83,0x04, /* 5 */
0x04,0x03,0x19,0x0e,0x09,0x01,0x0D,0x1A,0x14,0x06,0x0B,0x0F,0x12,0x1C,0x0C,0x18, /* 6 */
0x16,0x17,0x0a,0x05,0x10,0x07,0x1E,0x13,0x1D,0x15,0x11,0x88,0xc1,0x84,0x85,0x04, /* 7 */
0x03,0x19,0x13,0x1A,0x09,0x01,0x1E,0x11,0x06,0x0B,0x0F,0x12,0x1C,0x0C,0x18,0x16, /* 8 */
0x0A,0x05,0x10,0x07,0x0D,0x14,0x0E,0x0A,0x1A,0x14,0x05,0x15,0x1D,0x0D,0x0B,0x17, /* 9 */
0x03,0x19,0x13,0x1A,0x09,0x01,0x1E,0x11,0x06,0x0B,0x0F,0x12,0x1C,0x0C,0x18,0x16, /* A */
0x04,0x04,0x04,0x06,0x11,0x11,0x11,0x11,0x11,0x11,0x06,0x11,0x11,0x11,0x11,0x11, /* B */
0x11,0x11,0x11,0x11,0x03,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x1e,0x11,0x11, /* C */
0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x11,0x04,0x04,0x04,0x04,0x04, /* D */
0x0A,0x05,0x10,0x07,0x0D,0x14,0x0E,0x0A,0x1A,0x14,0x05,0x15,0x1D,0x0D,0x0B,0x17, /* E */
0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x04,0x19,0x04,0x04,0x04  /* F */
};


#define RUS 0x0
#define LAT 0x1f
#define NUM 0x1b
#define ZZZ 0x20          /*   */

//    
static BYTE registr_table[256]={
/*   1   2   3   4   5   6   7   8   9   A   B   C   D   E   F  */
RUS,ZZZ,ZZZ,ZZZ,ZZZ,NUM,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ, /* 0 */
RUS,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,NUM,ZZZ,ZZZ,ZZZ,LAT, /* 1 */
ZZZ,NUM,NUM,RUS,LAT,ZZZ,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM, /* 2 */
NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,ZZZ,ZZZ,NUM,ZZZ,NUM, /* 3 */
NUM,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT, /* 4 */
LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,NUM,ZZZ,ZZZ,NUM,ZZZ, /* 5 */
ZZZ,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT, /* 6 */
LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,LAT,ZZZ,ZZZ,ZZZ,NUM,ZZZ, /* 7 */
RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS, /* 8 */
RUS,RUS,RUS,RUS,RUS,RUS,RUS,NUM,NUM,NUM,NUM,RUS,RUS,NUM,NUM,RUS, /* 9 */
RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS,RUS, /* A */
ZZZ,ZZZ,ZZZ,LAT,NUM,NUM,NUM,NUM,NUM,NUM,LAT,NUM,NUM,NUM,NUM,NUM, /* B */
NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM, /* C */
NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,NUM,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ, /* D */
RUS,RUS,RUS,RUS,RUS,RUS,RUS,NUM,NUM,NUM,NUM,RUS,RUS,NUM,NUM,RUS, /* E */
ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ,ZZZ  /* F */
};

//  2 -> WIN
static BYTE mtk_win_table_lat[]="*E\nA SIU\rDRJNFCKTZLWHYPQOBG*MXV*";
static BYTE mtk_win_table_rus[]="*\n \r**";
static BYTE mtk_win_table_num[]="*3\n- '87\r?,:(5+)26019?*./=*";

//  
CTelex::CTelex()
{
}

//    
CTelex::CTelex(CString port)
{
	Connect(port);
}

//   
CTelex::~CTelex()
{
}

//   
BOOL CTelex::Connect(CString port)
{
	BOOL retv=m_at.Connect(port);
	m_at.SetModemTime(COleDateTime::GetCurrentTime());
	return retv;
}

//   
BOOL CTelex::Disconnect()
{
	return m_at.Disconnect();
}

//   
void CTelex::Lock()
{
	//        .
	while (m_at.IsModeRecv()) Sleep(50);

	//   ReceivLock  IBM_Read
	m_at.SetRecvLockMode(TRUE);
	m_at.SetIBMReadMode(TRUE);

	//        
	//   .
	while (!m_at.CanAccessBuffer()) Sleep(50);
}

//   
void CTelex::UnLock()
{
	//   ReceivLock  IBM_Read
	m_at.SetIBMReadMode(FALSE);
	m_at.SetRecvLockMode(FALSE);
}

//    
BYTE CTelex::Getc()
{
	return m_at.GetByte();
}

//      
void CTelex::Putc(BYTE b)
{
	m_at.WriteByte(b);
}

//    ( 10 )
void CTelex::ResetModem()
{
	m_at._Reset();
}

#define AATEXTLEN	135

//     
void CTelex::SendTlg(CString num, CString text,BOOL pulse)
{
	HeaderSendMsg hs;	// 
	CString numstr;		//  
	CString txtstr;		//   MTK
	WORD freemem;		//    
	WORD tlgsize;		//    
	WORD memsize;		//    
	int i;
	BYTE registr=ZZZ;


	//    
	text=text.Left(120);
	if (atoi(num)==0) num="00000";

	//   
	if (atoi(num)) {
		numstr+=(BYTE)((BYTE)'\x0a'+128);		//     
		numstr+=(BYTE)((BYTE)'\x0d'+128);		//  1 
	}
	for (i=0; i<num.GetLength(); i++)		//  
		numstr+=(BYTE)((BYTE)num[i]-(BYTE)'0'+128);
	if (atoi(num)) {
		numstr+=(BYTE)((BYTE)'\x0d'+128);		//  1 
	}
	numstr+=(BYTE)((BYTE)'\xff'+128);		//  

	//     MTK
	text.AnsiToOem(); txtstr="";
	for (i=0; i<text.GetLength(); i++) {
		BYTE newreg=registr_table[(BYTE)text[i]];
		if (registr!=newreg) {
			registr=newreg;
			if (registr!=ZZZ) txtstr+=(BYTE)(registr+128);
		}
		txtstr+=(CHAR)(alt_mtk_table[(BYTE)text[i]]+128);
	}

	//      
	tlgsize=sizeof(hs)+numstr.GetLength()+AATEXTLEN;

	//     
	hs.size=tlgsize;
	hs.type=atoi(num)?ET_FOR_SENDING:ET_AUTOANSWER;
	hs.errcode=EC_NO_ERRORS;
	hs.year=CTime::GetCurrentTime().GetYear()-1980+(atoi(num)?0:1);
	hs.month=CTime::GetCurrentTime().GetMonth();
	hs.day=CTime::GetCurrentTime().GetDay();
	hs.hh=CTime::GetCurrentTime().GetHour();
	hs.mm=CTime::GetCurrentTime().GetMinute();
	hs.prty=0;
	hs.callcounter=0;
	hs.uid=GetTickCount();
	hs.badcallssum=0;
	hs.badcallspod=0;
	hs.uchecknum.num=0;
	hs.uchecknum.ubyte.u1X=0x00;
	hs.uchecknum.ubyte.uYZ=0x10;
	hs.call.b1=0;
	hs.call.b2=0;
	hs.call.b3=0;
	hs.call.b4=0;
	hs.call.b5=0;
	hs.queuenum=0;

	//     
	freemem=m_at.GetFreeAddress();		// 1-  
	memsize=m_at.GetMemorySize();		//   

	if ((UINT)memsize-freemem<=sizeof(hs)+tlgsize+SEND_MEM_LIMIT) {
		AfxMessageBox("    \n"
			"    ");
		goto fin;
	}

	//         
	//  
	m_at._Poke(freemem+0,((BYTE *)&hs)[1]);		//   
	m_at._Poke(freemem+1,((BYTE *)&hs)[0]+1);	//  
	for (i=2; i<sizeof(hs); i++) 
		m_at._Poke(i+freemem,((BYTE *)&hs)[i]);
	freemem+=sizeof(hs);
	//  
	for (i=0; i<numstr.GetLength(); i++) 
		m_at._Poke(i+freemem,(BYTE)numstr[i]-128);
	freemem+=numstr.GetLength();
	//   
	for (i=0; i<txtstr.GetLength(); i++) 
		m_at._Poke(i+freemem,(BYTE)txtstr[i]-128);
	for (; i<=AATEXTLEN; i++) m_at._Poke(i+freemem,'\xff');
	freemem+=AATEXTLEN+1;

	//       
	//   
	//     
	hs.size=0;
	hs.type=ET_FOR_SENDING;
	hs.errcode=EC_NO_ERRORS;
	hs.year=CTime::GetCurrentTime().GetYear()-1980;
	hs.month=CTime::GetCurrentTime().GetMonth();
	hs.day=CTime::GetCurrentTime().GetDay();
	hs.hh=CTime::GetCurrentTime().GetHour();
	hs.mm=CTime::GetCurrentTime().GetMinute();
	hs.prty=0;
	hs.callcounter=0;
	hs.uid=GetTickCount();
	hs.badcallssum=0;
	hs.badcallspod=0;
	hs.uchecknum.num=0;
	hs.uchecknum.ubyte.u1X=0x00;
	hs.uchecknum.ubyte.uYZ=0x10;
	hs.call.b1=0;
	hs.call.b2=0;
	hs.call.b3=0;
	hs.call.b4=0;
	hs.call.b5=0;
	hs.queuenum=0;

	//         
	//   (  )
	m_at._Poke(freemem+0,((BYTE *)&hs)[0]);	//   
	m_at._Poke(freemem+1,((BYTE *)&hs)[1]);	//  
	for (i=2; i<sizeof(hs); i++) 
		m_at._Poke(i+freemem,((BYTE *)&hs)[i]);

	//        
	m_at.SetFreeAddress(freemem);	

fin: ;
}

//    ()
//    
//  
//   
WORD CTelex::GetQueueElement(WORD addr,BYTE *buf)
{
	int i;			
	WORD el_len;		//  
	BYTE el_type;		//  
	BYTE el_errcode;	//   ()

	//  ,    
	el_len=m_at._Peek(addr)*256+m_at._Peek(addr+1);

	el_type=m_at._Peek(addr+2);
	el_errcode=m_at._Peek(addr+3);

	printf("el_len=%d\n",el_len);

	//      
	for (i=2; i<el_len; i++) buf[i]=m_at._Peek(addr+i);
	*(WORD *)buf=el_len;		//   

	return el_len;
}

//    ()
//    
//  
void CTelex::DeleteQueueElement(WORD addr)
{
	m_at._Poke(addr+2,ET_DELETE_READ);
}


//     
BOOL CTelex::ConvertRecieved(const char *buf,CString &txt,BYTE *err,COleDateTime *t)
{
	BOOL retv=FALSE;
	BYTE yy,mn,dd,hh,mm;
	WORD size8,size5,size8x8;
	int i,j;
	BYTE registr=NUM;
	CString tmp;

	if (buf[2]!=ET_RECEIVED) goto fin;

	//   
	*err=buf[3];		//   ()
	yy=buf[4];			// -1980
	mn=buf[5];			// 
	dd=buf[6];			//  
	hh=buf[7];			// 
	mm=buf[8];			// 
	t->SetDateTime(yy+1980,mn,dd,hh,mm,0);

	//     8- 
	size8=(BYTE)buf[0]+((BYTE)buf[1])*256u-sizeof(HeaderRecevedMsg);
	size5=size8*8/5;

	//     2
	j=0;
	size8x8=size8*8;	//    
	for (i=0; i<size8; i+=5) {
		BYTE bb[8];
		BYTE *b5=(BYTE *)buf+sizeof(HeaderRecevedMsg)+i;
		//  5- 
		bb[0]=(((b5[0]>>3) & 0x1f));
		bb[1]=((((b5[0]<<2)&0x1c)|((b5[1]>>6)&3)));
		bb[2]=(((b5[1]>>1)&0x1f));
		bb[3]=((((b5[1]<<4)&0x10)|((b5[2]>>4)&0xf)));
		bb[4]=((((b5[2]<<1)&0x1e)|((b5[3]>>7)&1)));
		bb[5]=(((b5[3]>>2)&0x1f));
		bb[6]=((((b5[3]<<3)&0x18)|((b5[4]>>5)&7)));
		bb[7]=(((b5[4])&0x1f));

		tmp+=(BYTE)(bb[0]+128);	tmp+=(BYTE)(bb[1]+128);
		tmp+=(BYTE)(bb[2]+128);	tmp+=(BYTE)(bb[3]+128);
		tmp+=(BYTE)(bb[4]+128);	tmp+=(BYTE)(bb[5]+128);
		tmp+=(BYTE)(bb[6]+128);	tmp+=(BYTE)(bb[7]+128);
	}

	//    2   cp1251
	txt="";
	for (i=0; i<tmp.GetLength(); i++) {
		switch ((BYTE)(tmp[i]-128)) {
		case RUS: registr=RUS; break;
		case LAT: registr=LAT; break;
		case NUM: registr=NUM; break;
		case ZZZ: registr=ZZZ; break;
		default:
			switch (registr) {
			case RUS: txt+=mtk_win_table_rus[((BYTE)tmp[i])-128]; break;
			case LAT: txt+=mtk_win_table_lat[((BYTE)tmp[i])-128]; break;
			case NUM: txt+=mtk_win_table_num[((BYTE)tmp[i])-128]; break;
			default: txt+='?';
			}
		}
		retv=TRUE;
	}
fin:
	return retv;
}
